unit CommonMemory;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
   Dialogs, ExtCtrls;

type
  PInteger = ^Integer;

  { TCommonMemory NX }
  TCommonMemory = class(TObject)
  private
    { Private 錾 }
    FHandle: Integer; // L̃nh
    FMemory: Pointer; // L
    FSize: Integer; // L̃TCY
    FName: String; // L̖O
    FStr: String; // L̃f[^̕\
    FStrList: TStringList; // L̃f[^̕񃊃Xg\
    FProcessCount: Integer; // ݂̋Lgp̃vZX
    function GetStr: String;
    procedure SetStr(const Value: String);
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(const Name: String; Size: Longint);
    destructor Destroy; override;
    procedure Clear; virtual; // f[^[NA[B
    procedure Update; virtual; // StrList  Str ̃f[^vĂ Memory ɃRs[B
    { vpeB錾 }
    property Handle: Integer read FHandle;
    property Memory: Pointer read FMemory;
    property Size: Integer read FSize;
    property Name: String read FName;
    property Str: String read GetStr write SetStr;
    property StrList: TStringList read FStrList;
    property ProcessCount: Integer read FProcessCount;
end;

implementation

{ TPreviewBox }

constructor TCommonMemory.Create(const Name: String; Size: Longint);
var
  P: PInteger;
begin
  inherited Create;

  FHandle := 0;
  FMemory := Nil;
  FSize := 0;
  FName := Name;
  FStr := '';
  FStrList := TStringList.Create;
  FStrList.Duplicates := dupAccept;
  FProcessCount := 0;

  FHandle := OpenFileMapping(File_MAP_WRITE,
                             False,
                             PChar(FName));

  if FHandle = 0 then
    FHandle := CreateFileMapping($FFFFFFFF,
                                 Nil,
                                 PAGE_READWRITE,
                                 0,
                                 Size + 4, // FProcessCount ̕TCY𑝂₷B
                                 PChar(FName));

  if FHandle <> 0 then
    FMemory := MapViewOfFile(FHandle,
                             FILE_MAP_WRITE,
                             0,
                             0,
                             0);

  if FMemory <> Nil then
  begin
    FSize := Size;
    Longint(P) := Longint(FMemory) + FSize;
    FProcessCount := P^;
    Inc(FProcessCount); // gp̃vZX1₷B
    P^ := FProcessCount;
  end;
end;

destructor TCommonMemory.Destroy;
var
  P: PInteger;
begin
  Longint(P) := Longint(FMemory) + FSize;
  FProcessCount := P^;
  Dec(FProcessCount); // gp̃vZX1炷B
  P^ := FProcessCount;
  if FProcessCount < 1 then
  begin
    UnMapViewOfFile(FMemory); // }bsOB
    CloseHandle(FHandle); // L̃nhB
  end;
  FStrList.Free;
  inherited Destroy;
end;

procedure TCommonMemory.Clear;
begin
  FStr := '';
  FStrList.Clear;
  ZeroMemory(FMemory, FSize);
end;  

function TCommonMemory.GetStr: String;
begin
  FStr := PChar(FMemory); // f[^̕\
  Result := FStr;
end;

procedure TCommonMemory.SetStr(const Value: String);
var
  n: Integer;
begin
  FStr := Value; // f[^̕\
  n := Length(FStr) + 4; // TCY4oCgĂB
  if n > FSize then n := FSize;
  ZeroMemory(FMemory, n);
  CopyMemory(FMemory, PChar(FStr), n - 4);
end;

{ Str ̃f[^ StrList ƈvĂ Memory ɃRs[B}

procedure TCommonMemory.Update;
begin
  Str := StrList.Text;
end;

end.

